/*=======================================================================*/
/*																	     */
/*							CXDDR.cpp									 */
/*																		 */
/*						 CXDDRԱԴ						 */
/*																		 */
/*						    ߣZhanLi								 */
/*																		 */
/*=======================================================================*/

#include"CXDDR.h"
DD_Obj CXDDR::lpDD;
DD_SFace CXDDR::lpDDSPrimary;
DD_SFace CXDDR::lpDDSBack;
DWORD CXDDR::ScreenW;
DWORD CXDDR::ScreenH;
DWORD CXDDR::ScreenC;
HWND CXDDR::hWnd;
BOOL CXDDR::bFullScr;
DWORD CXDDR::FrameStartTime;
DWORD CXDDR::ScreenFPS;
//////////////////////////////////////////////////////////////////////////

//------------------[ ʾģʽṹ ]---------------------------

typedef struct _DISPLAYMODE {
    DD_SF_DESC * pddsdMode;
    DWORD dwNumMode;
}DISPLAYMODE;

DISPLAYMODE dmModes;

static HRESULT WINAPI ModeEnumRecord( DD_SF_DESC * pNewMode,
                                      VOID * pRecordInfo );
static BOOL WINAPI DDisplayEnumerate( GUID * pGUID, 
                                LPSTR ,
                                LPSTR ,
                                LPVOID , HMONITOR );
//////////////////////////////////////////////////////////////////////////

//------------------------[ CXDDR(...) 캯 ]---------------------------

CXDDR::CXDDR()
{
	//ʼ
	hWnd = NULL;
	bFullScr = TRUE;
	ScreenW = 640;
	ScreenH = 480;
	ScreenC = 16;
	lpDD = NULL;
	lpDDSPrimary = NULL;
	lpDDSBack = NULL;
	bUseColorKey=FALSE;
	bFramesBitmap=FALSE;
	x=0;y=0;
}

//////////////////////////////////////////////////////////////////////////

//------------------------[ ~CXDDR(...)  ]---------------------------

CXDDR::~CXDDR()
{
	if(lpDD!=NULL){
		if(lpDDSBack!=NULL){
			lpDDSBack->Release();
			lpDDSBack = NULL;
		}
		if(lpDDSPrimary!=NULL){
			lpDDSPrimary->Release();
			lpDDSPrimary = NULL;
		}
		lpDD->Release();
		lpDD = NULL;
	}
}

//////////////////////////////////////////////////////////////////////////

//---------------------------[ InitDDraw(...) ʼDiretDraw ]--------------------------

BOOL CXDDR::InitDDraw(HWND hWd,
					   BOOL bFScr,
					   DWORD ScrW,DWORD ScrH,
					   DWORD BitCount,DWORD dwRRate, DWORD SFps )
{
	//--------------------------ʼ
	hWnd=hWd;
	bFullScr=bFScr;
	ScreenFPS=SFps;
	if(bFScr){//ȫģʽ
		if(ScrW <= 640)		{ ScreenW = 640; ScreenH = 480; }
		else if(ScrW <= 800){ ScreenW = 800; ScreenH = 600; }
		else if(ScrW > 800) { ScreenW = 1024; ScreenH = 768; }
		else {ScreenW=800; ScreenH = 600;}
		if(BitCount<=8)		ScreenC = 8;
		else if(BitCount<=16)ScreenC = 16;
		else if(BitCount<=24)ScreenC = 24;
		else if(BitCount<=32)ScreenC = 32;
		else ScreenC=16;

        //ģʽǷЧ
        CheckDisplayMode();
	}
	else{//ģʽ
		ScreenW=ScrW;
		ScreenH=ScrH;
	}

	//--------------------------ʼDirectDraw
	HRESULT ddrval;
	//DirectDraw
	ddrval = DirectDrawCreateEx(NULL,(void **) &lpDD,IID_IDirectDraw7,NULL);
	if( FAILED(ddrval) )	{
		//DirectDrawʱ
		//Լ¼DirectDrawĳϢ
		return FALSE;
	}
	//******ȫģʽ***********//
	if( bFullScr ){
		//Эȼ
		ddrval = lpDD->SetCooperativeLevel( hWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT );
		if( FAILED( ddrval )){
			//Эȼʱ
			//Լ¼ЭȼĳϢ
			return FALSE;
		}

		//ʾģʽ
		ddrval = lpDD->SetDisplayMode( ScreenW,ScreenH,ScreenC,dwRRate,NULL);
		if( FAILED( ddrval ) ){
			//ʾģʽʱ
			//Լ¼ʾģʽĳϢ
			return FALSE;
		}

		//
	    DD_SF_DESC ddsd;
	    ZeroMemory(&ddsd,sizeof(ddsd));
	    ddsd.dwSize = sizeof( ddsd );
	    ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
	    ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE |
							  DDSCAPS_FLIP |
							  DDSCAPS_COMPLEX;
	    ddsd.dwBackBufferCount = 1;
		ddrval = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );
		if (ddrval!=DD_OK) {
			//ʱ
			//Լ¼ĳϢ
			return FALSE;
		}

		//̨
		DDSCAPS2 ddscaps;
		ZeroMemory(&ddscaps,sizeof(ddscaps));
		ddscaps.dwCaps=DDSCAPS_BACKBUFFER;
		ddrval=lpDDSPrimary->GetAttachedSurface(&ddscaps,&lpDDSBack);
		if (ddrval!=DD_OK) {
			//ȡ̨ʱ
			//Լ¼̨ĳϢ
			return FALSE;
		}
		return TRUE;
	}
	//******ģʽ***********//
	else{
		//Эȼ
		ddrval=(HRESULT)lpDD->SetCooperativeLevel( hWnd, DDSCL_NORMAL );

		//
		DD_SF_DESC 	ddsd;
		ZeroMemory( &ddsd, sizeof(ddsd) );
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;
	    //棬ȡָָlpDDSPrimary
		ddrval = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );
		if( FAILED( ddrval )){
			//ʱ
			//Լ¼ĳϢ
			return FALSE;
		}

        //ʹòü
        UseClipper();

		//̨
		//:::::::ddsdǰѾ
		ZeroMemory(&ddsd,sizeof(ddsd));
		ddsd.dwSize=sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT |DDSD_WIDTH;
		ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDSCAPS_SYSTEMMEMORY;
		ddsd.dwWidth  = ScreenW;//ķֱ
		ddsd.dwHeight = ScreenH;//ߵķֱ
		//һ̨
		ddrval = lpDD->CreateSurface( &ddsd, &lpDDSBack, NULL );
		if( FAILED( ddrval )){
			//̨ʱ
			//Լ¼̨ĳϢ
			return FALSE;
		}
	}

    return TRUE;
	//--------------------------ʼDirectDraw
}
//////////////////////////////////////////////////////////////////////////



//------------------------[ Flip(...) ת==>ʾ]--------------------------------
 
void CXDDR::Flip( LPRECT pRectWin )
{
    HRESULT   ddrval=1;
	FixFps();
    if( lpDDSPrimary && lpDDSBack )
    {
        //Ƿʧ
        if (lpDDSPrimary->IsLost()==DDERR_SURFACELOST)
            lpDDSPrimary->Restore();
        if (lpDDSBack->IsLost()==DDERR_SURFACELOST)
            lpDDSBack->Restore();
        do{
            if(bFullScr==1)
                ddrval = lpDDSPrimary->Flip( NULL, DDFLIP_WAIT );
            else
                ddrval = lpDDSPrimary->Blt( pRectWin,lpDDSBack,NULL,DDBLT_WAIT,NULL);

            //תϢ
            if( ddrval == DD_OK )
                break;
            else if( ddrval == DDERR_SURFACELOST ){
                if( FAILED(lpDDSBack->Restore()) )
                    break;
                if( FAILED(lpDDSPrimary->Restore()) )
                    break;
            }
            else if( ddrval != DDERR_WASSTILLDRAWING )
                break;
        }while( 1 );
    }

}
//////////////////////////////////////////////////////////////////////////





//--------------[ UseClipper(...) һü, ]-------------

HRESULT CXDDR::UseClipper( void )
{
    HRESULT ddrval;
    LPDIRECTDRAWCLIPPER lpClipper = NULL;

    //һ
    ddrval = lpDD->CreateClipper(0, &lpClipper, NULL);
    if ( ddrval != DD_OK){
        //CreateClipper
        //Լ¼Ϣ
        return ddrval;
    }
    
    //üΪhWndָĴڵĿͻķΧ
    ddrval = lpClipper->SetHWnd(0, hWnd);
    if ( ddrval != DD_OK){
        //SetHWndôھ
        //Լ¼Ϣ
        return ddrval;
    }

    //ü
    ddrval = lpDDSPrimary->SetClipper(lpClipper);
    if ( ddrval != DD_OK){
        //ü
        //Լ¼Ϣ
        return ddrval;
    }

    //ѾԶ˲üֵ,Ӧͷ
    if( lpClipper != NULL ) { 
        lpClipper -> Release();
        lpClipper = NULL; 
    } 

    return DD_OK;
}
//////////////////////////////////////////////////////////////////////////





//-------[ LoadBMPSurface(...) BitmapFileָλͼʽͼոSurfָı ]-----------

BOOL CXDDR::LoadBMPSurface(DD_SFace &lpSurf,  //Ҫͼıָ
							LPCSTR BitmapFile )//Դͼ·
{
    HDC                 hdcImage;
    HDC                 hdc;
    HBITMAP             hbm;
    BITMAP              bm;
    HRESULT				ddrval;

    if( lpSurf == NULL )
        return FALSE;
    // λͼΪļȡ
    hbm = (HBITMAP)LoadImage(NULL,
							BitmapFile,
							IMAGE_BITMAP,
							0, 0,
							LR_LOADFROMFILE |
							LR_CREATEDIBSECTION);
    if (hbm == NULL){
        //ͼʧʱ
        //Լ¼ͼʧܵϢ
		return FALSE;
	}
	//ܣһָ豸ݵڴ豸Ļ(Device Context)
	//һӦóĵǰʾݵڴ豸Ļ
    hdcImage = CreateCompatibleDC(NULL);
    if (!hdcImage){
		//豸ĳ
		return FALSE;
	}
	//ѡλͼ󵽸ոմڴ豸ĻDC
    SelectObject(hdcImage, hbm);

	//ȡλͼ
    GetObject(hbm, sizeof(bm), &bm);

	//ȡĿ
	DD_SF_DESC		ddsd;
    ddsd.dwSize = sizeof(ddsd);
    lpSurf->GetSurfaceDesc(&ddsd);
	if( BitmapFile!=NULL )
	{
        if ((ddrval = lpSurf->GetDC(&hdc)) == DD_OK)
        {
			//ԴλͼƵ棬Խ
            StretchBlt( hdc,
						0, 0, ddsd.dwWidth, ddsd.dwHeight,
						hdcImage,
						0, 0, bm.bmWidth, bm.bmHeight,
						SRCCOPY);
            lpSurf->ReleaseDC(hdc);
        }
	}

	DeleteDC(hdcImage);

	if( ddrval != DD_OK )  { 
		//ƾοʧ
		return FALSE;
	}

	return TRUE;
}
//////////////////////////////////////////////////////////////////////////




//--------------------------[ CreateBMPSurface(...) ]--------------------------
/*
   :   lpSurfָı,ҽBitmapFile
           ָλͼʽͼոմı
   ˵: lpSurf : Ҫͼıָ
             WH : ıĿ(Ϊʾͼƥ)
             BitmapFile : Դͼ·
             MemoryFlag : ͼĴ洢ʽ
                          Դ:DDSCAPS_VIDEOMEMORY
                          ϵͳڴ:DDSCAPS_SYSTEMMEMORY
   ע:   ָ泤ʱ(W,H),ĳԲ
           ָͼĳ
*/

BOOL CXDDR::CreateBMPSurface(DD_SFace &lpSurf,
								LONG W,LONG H,
								LPCSTR BitmapFile,
								DWORD MemoryFlag)
{
    HBITMAP             hbm;
    BITMAP              bm;
	BOOL				bResult;

    // λͼΪļȡ
    hbm = (HBITMAP)LoadImage(NULL,
							BitmapFile,
							IMAGE_BITMAP,
							0, 0,
							LR_LOADFROMFILE |
							LR_CREATEDIBSECTION);
    if (hbm == NULL){
        //ͼʧʱ
        //Լ¼ͼʧܵϢ
		return FALSE;
	}

    //ҪıĿ
	GetObject(hbm, sizeof(bm), &bm);
	W = W == 0 ? bm.bmWidth  : W;
	H = H == 0 ? bm.bmHeight : H;
	lpDDS_Width=W;
	lpDDS_Height=H;

    //Ŀߴһ
    bResult = CreateNULLSurface( lpSurf, W, H, DDSCAPS_SYSTEMMEMORY );

	if( bResult != TRUE )   {
		//ʱ
		//Լ¼ĳϢ
	}
	else if( BitmapFile!=NULL )	{
        //BitmapFileָͼļSurf
        bResult = LoadBMPSurface( lpSurf, BitmapFile );
	}

    DeleteObject(hbm);

	return bResult;
}

//////////////////////////////////////////////////////////////////////////




//--------------------------[  CreateNULLSurface(...) ]--------------------------
/*
    
   :       Surfָı,ǿձ
   ˵:   lpSurf : Ҫıָ
               WH : ıĿ
               MemoryFlag : ͼĴ洢ʽ
                           Դ:DDSCAPS_VIDEOMEMORY
                           ϵͳڴ:DDSCAPS_SYSTEMMEMORY
*/

BOOL CXDDR::CreateNULLSurface(DD_SFace &lpSurf,
								LONG W,LONG H,
								DWORD MemoryFlag)
{
	DD_SF_DESC     ddsd;
	HRESULT            ddrval;

	//Ҫ
	ZeroMemory(&ddsd,sizeof(ddsd));
	ddsd.dwSize=sizeof(ddsd);
    ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT |DDSD_WIDTH;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | MemoryFlag;
	ddsd.dwWidth  = W;
	ddsd.dwHeight = H;

	//һ


	ddrval = lpDD->CreateSurface( &ddsd, &lpSurf, NULL );
	if( ddrval != DD_OK )   
		return FALSE;
		
	return TRUE;
}
//////////////////////////////////////////////////////////////////////////






//--------------------------[ Blit(...) λͼ ]--------------------------

HRESULT	CXDDR::Blit( DD_SFace lpSurfDest,//Ŀָ
                      LONG x,LONG y,//ƵĿλ
                      DD_SFace lpSurfSrc,
                      RECT * pRtSrc,//ҪƵԴͼƬλáֵΪNULLʾ
                      DWORD dwTrans //͵ķʽ
					  )
{
	HRESULT			ddrval;

    //------------------鲢޸Դεĺ
	DD_SF_DESC	ddsdSrc;
	try{
	
	ddsdSrc.dwSize=sizeof(ddsdSrc);
	ddrval=lpSurfSrc->GetSurfaceDesc(&ddsdSrc);
    if( ddrval == DD_OK && pRtSrc != NULL ) {
        LONG srcW = ddsdSrc.dwWidth;
        LONG srcH = ddsdSrc.dwHeight;
        if( srcH < pRtSrc->bottom )
            pRtSrc->bottom = srcH;
        if( srcH < pRtSrc->top )
            pRtSrc->top = srcH;
        if( srcW < pRtSrc->right )
            pRtSrc->right = srcW;
        if( srcW < pRtSrc->left )
            pRtSrc->left = srcW;
        if( pRtSrc->top < 0 )
            pRtSrc->top = 0;
        if( pRtSrc->bottom < 0 )
            pRtSrc->bottom = 0;
        if( pRtSrc->left < 0 )
            pRtSrc->left = 0;
        if( pRtSrc->right < 0 )
            pRtSrc->right = 0;
    }

    //------------------ԴΰĿС
	DD_SF_DESC	ddsdDest;
	ddsdDest.dwSize=sizeof(ddsdDest);



	ddrval=lpSurfDest->GetSurfaceDesc(&ddsdDest);
	if( ddrval != DD_OK ) {
        //޷֪ĿĿ
        return ddrval;
    }
    else if(pRtSrc != NULL){
        LONG destW = ddsdDest.dwWidth;
        LONG destH = ddsdDest.dwHeight;
        if(x<0){//Ŀ
            if((-x)>(pRtSrc->right-pRtSrc->left))
                return DD_FALSE;//ȫĿ
            pRtSrc->left=pRtSrc->left-x;
            x=0;
        }
        if(x>(destW-(pRtSrc->right-pRtSrc->left)) ){
            //Ŀұ
            if(x>destW)
                return DD_FALSE;//ȫĿұ
            else
                pRtSrc->right=destW+pRtSrc->left-x;
        }
        if(y<0){//Ŀϱ
            if((-y)>(pRtSrc->bottom-pRtSrc->top))
                return DD_FALSE;//ȫĿϱ
            pRtSrc->top=pRtSrc->top-y;
            y=0;
        }
        if(y>(destH-(pRtSrc->bottom-pRtSrc->top)) ){
            //Ŀĵױ
            if(y>destH)
                return DD_FALSE;//ȫĿĵױ
            else
                pRtSrc->bottom=destH+pRtSrc->top-y;
        }
    }

	//-----------------λ鴫
	while( 1 )
	{
        if( pRtSrc != NULL )
            ddrval=lpSurfDest->BltFast(x,y,lpSurfSrc,pRtSrc,dwTrans);
        else {
            if(dwTrans == DDBLTFAST_SRCCOLORKEY || dwTrans == DDBLT_KEYSRC)
                ddrval=lpSurfDest->Blt( NULL,lpSurfSrc,
                                        NULL,DDBLT_WAIT | DDBLT_KEYSRC,
                                        NULL);
            else if(dwTrans == DDBLTFAST_DESTCOLORKEY || dwTrans == DDBLT_KEYDEST)
                ddrval=lpSurfDest->Blt( NULL,lpSurfSrc,
                                        NULL,DDBLT_WAIT | DDBLT_KEYDEST,
                                        NULL);
            else
                ddrval=lpSurfDest->Blt( NULL,lpSurfSrc,
                                        NULL,DDBLT_WAIT,
                                        NULL);
        }
        if(	ddrval == DD_OK )
            return ddrval;
        else if( ddrval == DDERR_SURFACELOST ){
            ddrval = lpDDSBack->Restore();
            ddrval = lpDDSPrimary->Restore();
            if( ddrval != DD_OK )
                return ddrval;
        }
        else if( ddrval != DDERR_WASSTILLDRAWING )
            return ddrval;
    }

    return ddrval;
		}
	catch (...) {
return FALSE;
    }
}//////////////////////////////////////////////////////////////////////////





//--------------------------[ Blit(...) ָԴͼƬ͵̨ ]--------------------------

HRESULT CXDDR::BlitBack( LONG x,LONG y,
                      DD_SFace lpSurfSrc,
                      RECT * pRtSrc,
                      DWORD dwTrans )
{
    return Blit( lpDDSBack,x,y,lpSurfSrc,pRtSrc,dwTrans );
}
//////////////////////////////////////////////////////////////////////////





//--------------------[ CheckDisplayMode(...) ʾ豸Ƿ֧趨ʾģʽ ]---------------------

void CXDDR::CheckDisplayMode( void )
{
    DirectDrawEnumerateEx( DDisplayEnumerate, NULL, 0 );
    DWORD i=0;
    do{
        if(dmModes.pddsdMode[i].dwWidth == ScreenW &&
            dmModes.pddsdMode[i].dwHeight == ScreenH ){
            if(dmModes.pddsdMode[i].ddpfPixelFormat.dwRGBBitCount== ScreenC )
                break;
        }
        ++i;

        //õģʽ֧,ʹõһ鵽ģʽ
        if(i==dmModes.dwNumMode){
            ScreenW = dmModes.pddsdMode[0].dwWidth;
            ScreenH = dmModes.pddsdMode[0].dwHeight;
            ScreenC = dmModes.pddsdMode[0].ddpfPixelFormat.dwRGBBitCount;
            MessageBox( NULL,
                "ʾ豸֧õʾģʽ,ʹòҵĵһģʽ!",
                "Warning!", MB_OK) ;
        }
    }while(i<dmModes.dwNumMode);

    //ͷڻصпĿռ
    delete dmModes.pddsdMode;
}
//////////////////////////////////////////////////////////////////////////








//---------[ DDColorMatch(...) ]------------------
/*

  rgbָɫֵӦpddsֵ
  rgbֵCLR_INVALID,ʹñ
       ϽǵΪؼɫ

*/

DWORD CXDDR::DDColorMatch(DD_SFace pdds, COLORREF rgb)
{
    if( pdds == NULL )
	    return 0x00000000;

    COLORREF rgbT;
    HDC hdc;
    DWORD dw = CLR_INVALID;
    DD_SF_DESC ddsd;
    HRESULT hres;

    //---------Ͻǵɫ滻ΪҪõɫֵ
    if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
    {
        rgbT = GetPixel(hdc, 0, 0);
        SetPixel(hdc, 0, 0, rgb);
        pdds->ReleaseDC(hdc);
    }

    //---------ֱӶԱж
    ddsd.dwSize = sizeof(ddsd);
    hres = pdds->Lock(NULL, &ddsd, DDLOCK_WAIT, NULL);
    if (hres == DD_OK)
    {
        /*
        ȡһ,Ͻǵڱݻֵ
        Ǳɫʽܲ32λɫ,Ը
        ֵҪõɫֵĶӦ
        */
        dw  = *(DWORD *)ddsd.lpSurface;

        /*
        ɫʽܲ32λɫ,ֻɫ
        ʽӦλ磺16λȵľֻҪdwǰ16
        λֵ,򷽷dw & 0xffff8λdw & 0xff
        32λɫȵĸʽ,ֵʹɫֵ,Բ
        */
        if( ddsd.ddpfPixelFormat.dwRGBBitCount < 32 )
			dw &= (1 << ddsd.ddpfPixelFormat.dwRGBBitCount)-1; 
        pdds->Unlock(NULL);
    }

    //---------ָ滻Ͻǵɫֵ
    if (rgb != CLR_INVALID && pdds->GetDC(&hdc) == DD_OK)
    {
        SetPixel(hdc, 0, 0, rgbT);
        pdds->ReleaseDC(hdc);
    }

    return dw;
}
//////////////////////////////////////////////////////////////////////////







//--------------------------[ DDSetColorKey(...) ]--------------------------

/*
 
  :    pddsָıĹؼɫ
  ˵: rgbֵCLR_INVALID,ʹñ
        ϽǵΪؼɫ
*/

HRESULT CXDDR::DDSetColorKey(DD_SFace pdds, COLORREF rgb)
{
    DDCOLORKEY          ddck;

    ddck.dwColorSpaceLowValue  = DDColorMatch(pdds, rgb);
    ddck.dwColorSpaceHighValue = ddck.dwColorSpaceLowValue;
    return pdds->SetColorKey(DDCKEY_SRCBLT, &ddck);
}
//////////////////////////////////////////////////////////////////////////







//--------------------------[ GetRect(...) ȡһνṹ ]--------------------------

RECT CXDDR::GetRect(LONG left,LONG top,LONG right,LONG bottom)
{
    RECT rect = {left,top,right,bottom};
    return rect;
}
//////////////////////////////////////////////////////////////////////////






//--------------------------[ ModeEnumRecord(...) ¼⵽ʾģʽ ]--------------------------

static HRESULT WINAPI ModeEnumRecord( DD_SF_DESC * pNewMode,
                                      VOID * pRecordInfo )
{
    DISPLAYMODE * pAllModes = NULL;
    DD_SF_DESC * pddsdNewAllModes = NULL;

    //ȡ¼ָ
    pAllModes = ( DISPLAYMODE * )pRecordInfo;

    //Ϊģʽбռ,ͬʱҲΪҵģʽռ
    pddsdNewAllModes = new DD_SF_DESC [pAllModes->dwNumMode+1];

    /*
    ԭģʽбռֱӸƵ·Ŀռ䡣Ŀǰ,б
    һûм¼*/
    DWORD dwSize = pAllModes->dwNumMode * sizeof(DD_SF_DESC);
    memcpy( pddsdNewAllModes, pAllModes->pddsdMode, dwSize );

    //ɾ˵Ŀռ,ָָµĿռ
    delete pAllModes->pddsdMode;
    pAllModes->pddsdMode = pddsdNewAllModes;

    //ҵʾģʽ¼(¼бռһ)
    pAllModes->pddsdMode[pAllModes->dwNumMode] = (*pNewMode);

    //ģʽбֵ
    ++pAllModes->dwNumMode;

    return DDENUMRET_OK;
}

//////////////////////////////////////////////////////////////////////////







//--------------------------[ DDisplayEnumerate(...) ʾֵ֧ʾģʽ ]--------------------------

static BOOL WINAPI DDisplayEnumerate( GUID * pGUID,  
                                LPSTR ,
                                LPSTR ,
                                LPVOID , HMONITOR )
{
    HRESULT hr;
	DD_Obj    lpDD;
	//DirectDraw
	hr = DirectDrawCreateEx(pGUID,(void **) &lpDD,IID_IDirectDraw7,NULL);
	if( FAILED(hr) )	{
        //DirectDrawʱ
        //Լ¼Ϣ
		return false;
	}

    //صModeEnumRecord
    hr = lpDD->EnumDisplayModes( 0, NULL, 
                                 (LPVOID)&dmModes,
                                 ModeEnumRecord);

    lpDD->Release();
    return hr;

}
//////////////////////////////////////////////////////////////////////////





/************************************************************************/
/*                  λͼ                                            */
/************************************************************************/
void CXDDR::LoadBMP (LPCSTR BitmapFile)//Сλͼ
	{
	CreateBMPSurface (lpDDSurface,0,0,BitmapFile,DDSCAPS_VIDEOMEMORY);
	bUseColorKey=FALSE;
	bFramesBitmap=FALSE;
	}

void CXDDR::LoadBMP (LPCSTR BitmapFile,LONG W,LONG H)//ָС
	{
	CreateBMPSurface (lpDDSurface,W,H,BitmapFile,DDSCAPS_VIDEOMEMORY);
	bUseColorKey=FALSE;
	bFramesBitmap=FALSE;
	}
/************************************************************************/
/*                  ɫ                                          */
/************************************************************************/
void CXDDR::SetColorKey (COLORREF rgb)
	{
	DDSetColorKey (lpDDSurface,rgb);
	bUseColorKey=TRUE;
	}
void CXDDR::SetColorKey ()
	{
	DDSetColorKey (lpDDSurface,CLR_INVALID);
	bUseColorKey=TRUE;
	}
/************************************************************************/
/*                                                        */
/************************************************************************/
void CXDDR::SendToBack (RECT rect)
	{
	if (bUseColorKey) {	
	BlitBack (x,y,lpDDSurface,&rect,DDBLTFAST_SRCCOLORKEY);
		}
	else{
	BlitBack (x,y,lpDDSurface,&rect,DDBLTFAST_NOCOLORKEY);
	}
	}
//-----------------------------------------------------------------
void CXDDR::SendToBack ()
	{
	RECT rect;
	if (bFramesBitmap) 
		rect=FramesRect;
	else
		rect=GetRect(0,0,1000,1000);
	if (bUseColorKey) {	
		BlitBack (x,y,lpDDSurface,&rect,DDBLTFAST_SRCCOLORKEY);
		}
	else{
		BlitBack (x,y,lpDDSurface,&rect,DDBLTFAST_NOCOLORKEY);
		}
	}
//////////////////////////////////////////////////////////////////////////
/*************************************************************************
						ܺ
*************************************************************************/
/*
֡
*/

void CXDDR::SetFrames (LONG lActStart,WORD lIndex,LONG ActWidth,LONG ActHeight,LONG lCountInLine)
	{
	ActIndex=lActStart;
	Index=lIndex;
	lWidth=ActWidth;
	lHeight=ActHeight;
	lCount=lCountInLine;
	bFramesBitmap=TRUE;
	lpDDS_Width=ActWidth;
	lpDDS_Height=ActHeight;
	}

/*
 õǰ	
 */

void CXDDR::SetActType (WORD lIndex)
	{
	Index=lIndex;
	}


/*******************************************************

				 GetActionRect(...)

	ݶȡöԴͼƬľλ

********************************************************/
void CXDDR::GetActionRect()
	{
	LONG x,y;
	//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	//ڵڼ(0,1,2,3,...ϵ)
	y = (LONG)( ActIndex/lCount);

	//еĵڼ(0,1,2,3,...)
	x = ActIndex - y*lCount;

	FramesRect.left	= x*lWidth;
	FramesRect.top	= y*lHeight;

	FramesRect.right	= FramesRect.left + lWidth;
	FramesRect.bottom	= FramesRect.top + lHeight;
	//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
	}




/*******************************************************

   DoActions(...)

    : lFrames   һ֡

********************************************************/
void CXDDR::DoActions(LONG lFrames)
	{
	// ڵڶҲСڵһ
	if(ActIndex<( lFrames-1+Index)
		&& ActIndex>=Index )
		++ActIndex;
	// һתһ
	// ߸ոתѭ
	else
		ActIndex = Index;
GetActionRect();
	}
/**************
GetActType()
ȡ
**************/
LONG CXDDR::GetActType()
	{
	return Index;
	}
/**************
GetAct()
ȡ
**************/
LONG CXDDR::GetAct()
	{
	return ActIndex;
	}
/*
 *	֡
 */
void CXDDR::FixFps()
	{if(ScreenFPS){
	while( ( GetTickCount() - FrameStartTime ) < (DWORD)(1000/ScreenFPS) );

	FrameStartTime = GetTickCount();
		}
	}
/*
 *	ر
 */
DWORD CXDDR::Get_lpDDS_W()
	{
	return lpDDS_Width;
	}

/*
*	ر
*/
DWORD CXDDR::Get_lpDDS_H()
	{
	return lpDDS_Height;
	}