/*=======================================================================*/
/*																	     */
/*							CXDSD.h										 */
/*																		 */
/*						 CXDSD									 */
/*																		 */
/*						 ߣZhangLi									 */
/*																		 */
/*=======================================================================*/
#pragma	once
#include <dsound.h>

#pragma comment(lib,"dxguid.lib")
#pragma comment(lib,"dsound.lib")
#pragma comment(lib,"winmm.lib")

#define PLAYING			10001
#define STOPPED			10002
#define PAUSED			10003

#define STREAMSOUND		20001
#define STATICSOUND		20002

typedef struct _STREAMDESC {
    LONG        lBufSection;
    LONG        lBufPos;
    LONG        lBufSize;
    LPDIRECTSOUNDBUFFER lpBuffer;

    WAVEFORMATEX wfx;//ݸʽ

    LONG        lDataPos;//ļеĶȡݵα
    LONG        lDataLen;
    LPCSTR      filename;
    LONG        lSecondsLen;//ļݵʱ䳤()
    LONG        lMillisecsHalfBuf;//һܲŵʱ()
    LONG        lReadLen;//һζȡ
    BOOL        bLoop;
    BOOL        bStaticBuffer;
} STREAMDESC, *LPSTREAMDESC;

class ZLSOUND
{

//--------------------------[ ʼȫֲ ]--------------------------
public:

	//TODO: 캯
    ZLSOUND( DWORD dwNum, DWORD dwCL );
    ZLSOUND( void );

	//TODO: 
    ~ZLSOUND();

    //TODO: Эȼ
    void Set_dwCoopLevel( DWORD dwCL );

	//TODO: Ƿʽ
    void Set_bSetPrimaryFormat( BOOL bSetFormat );

	//TODO: ʼDirectSound
    BOOL InitDSound( HWND hWnd );

	//TODO: ʽ
    BOOL SetPrimaryBufferFormat( DWORD dwChannels,
                                 DWORD dwSamplesPerSec,
                                 DWORD dwBitsPerSample );

	//TODO: ͷDirectSound
    void ReleaseDSound(void);


	//TODO: ļ
    BYTE *LoadWaveFile(WAVEFORMATEX *format,
                        DWORD        *pdwDataLen,
                        LPCSTR       filename,
                        BOOL         bReadData);
protected:
	//TODO: »ȡ
    void RestoreBuffer( LPDIRECTSOUNDBUFFER lpBuf );


//--------------------------[ ̬زԱ ]--------------------------
protected:
    LPDIRECTSOUNDBUFFER *ppBuffer;//μ̬׵ַ
    DWORD    dwNumStatics;//жٸ̬
    DWORD    dwMaxBytesStatic;//̬ռֵ

public:
    // þ̬ĳԱ
    void Set_dwMaxBytesStatic( DWORD dwBytes )
    {
        dwMaxBytesStatic = dwBytes;
    }
    void Set_dwNumStatics( DWORD dwNum );

    // ̬Ĵͷ
    BOOL CreateStaticBuffer( DWORD dwIndex, LPCSTR filename);
    void ReleaseStaticBuffer( DWORD dwIndex );

    // ̬ſ
    void PlayStatic( DWORD dwIndex,BOOL bLoop,BOOL bCompulsory);
    void StopStatic( DWORD dwIndex );
    BOOL StaticIsPlaying( DWORD dwIndex );

    // ̬
    void SetStaticVolume( DWORD dwIndex, LONG lVolume );
    void AddStaticVolume( DWORD dwIndex, LONG lAdd );
    void SubStaticVolume( DWORD dwIndex, LONG lSub );

    // ̬Ե
    void SetStaticPan( DWORD dwIndex, LONG lPan );
    void AddStaticPan( DWORD dwIndex, LONG lAdd );
    void SubStaticPan( DWORD dwIndex, LONG lSub );

    // ̬Ƶʵ
    void SetStaticFreq( DWORD dwIndex, DWORD dwFreq );
    void AddStaticFreq( DWORD dwIndex, DWORD dwAdd );
    void SubStaticFreq( DWORD dwIndex, DWORD dwSub );

    // ⲿ
    LPDIRECTSOUNDBUFFER Get_pStaticBuffer( DWORD dwIndex );
    DWORD  Get_dwMaxBytesStatic(void){return dwMaxBytesStatic;}
    DWORD  Get_dwNumStatics( void )  {return dwNumStatics;}

    //>>>>>>>>>> ʽزԱ >>>>>>>>>>>>>>>
protected:
    LPSTREAMDESC *ppStream;//μʽ׵ַ
    DWORD        dwNumStreams;//ʽĸ
    DWORD        dwMaxBytesStream;//ʽռֵ

public:
    void Set_dwMaxBytesStream( DWORD dwBytes )
    {
        dwMaxBytesStream = ( (DWORD)(dwBytes/8) )*8;
    }
    void Set_dwNumStreams( DWORD dwNum );

    // ʽĴպͷ
    BOOL CreateStreamBuffer( DWORD dwIndex, LPCSTR filename );
    void ClearStreamBuffer( DWORD dwIndex );
    void ReleaseStreamBuffer( DWORD dwIndex );

    // ʽĲֹͣ
    void PlayStream( DWORD dwIndex, BOOL bLoop );
    void PauseStream( DWORD dwIndex );
    void StopStream( DWORD dwIndex );

    // ݵĲα
    void SetStreamPos( DWORD dwIndex, LONG lPos );
    void AddStreamPos( DWORD dwIndex, LONG lAdd );
    void SubStreamPos( DWORD dwIndex, LONG lSub );

    // ʽ
    void AddStreamVolume( DWORD dwIndex, LONG lAdd );
    void SubStreamVolume( DWORD dwIndex, LONG lSub );

    // ʽ,Լʽ
    BYTE *LoadStreamData( DWORD dwIndex );
    BOOL UpdateStreamBuffer( DWORD dwIndex );

    // ⲿ
    LPSTREAMDESC* Get_ppStream(void){return ppStream;}
    DWORD Get_dwMaxBytesStream(void){return dwMaxBytesStream;}
    DWORD Get_dwNumStreams(void)    {return dwNumStreams;}
public:

	// ⲿóԱ
	LPDIRECTSOUND8 Get_lpDSound(void){return lpDSound;}
DWORD Get_dwCoopLevel(void)      {return dwCoopLevel;}
BOOL  Get_bSetPrimaryFormat(void){return bSetPrimaryFormat;}

protected:
	LPDIRECTSOUND8      lpDSound;//DirectSound
	BOOL                bSoundAble;//豸Ƿ

	DWORD               dwCoopLevel;//Эȼ
	BOOL                bSetPrimaryFormat;//Ƿĸʽ


};
class CXDSD
	{

public:


	CXDSD(){
	Sound.Set_dwMaxBytesStream(1024000);
	};

	CXDSD(DWORD SoundTp,HWND hwnd)
		{

		hWnd=hwnd;
		Sound.Set_dwMaxBytesStream(1024000);
		if (SoundTp==STATICSOUND) 
			{
			++staticCount;
			Index=staticCount-1;
			SoundType=SoundTp;
			}
		

		else if (SoundTp==STREAMSOUND) 
			{
			++streamCount;
			Index=streamCount-1;
			SoundType=SoundTp;
			}

		}

~CXDSD(){}



BOOL LoadWav(LPCSTR FileName){
	
	if(!Initted){Init();}

if (SoundType==STATICSOUND) {

	Sound.CreateStaticBuffer(Index,FileName);
}

else if (SoundType==STREAMSOUND) {

Sound.CreateStreamBuffer(Index,FileName);


}
return TRUE;
	
	}


	void Play(BOOL bLoop,BOOL bCompulsory)
		{

		if(SoundType==STATICSOUND)
		Sound.PlayStatic(Index,bLoop,bCompulsory);

		else if(SoundType==STREAMSOUND)
		Sound.PlayStream(Index,bLoop);

		


		}

	void Stop(){
		
		if(SoundType==STATICSOUND)
			Sound.StopStatic(Index);

		else if(SoundType==STREAMSOUND)
			Sound.StopStream(Index);

		
		
		}
	void Pause()
		{
		if(SoundType==STATICSOUND)
			Sound.StopStatic(Index);

		else if(SoundType==STREAMSOUND)
			Sound.PauseStream(Index);

		

		}
	DWORD getState(){
		
		if(Sound.StaticIsPlaying(Index))SoundState=PLAYING;
		return SoundState;

		}


void AddVolume(LONG lAdd){
	
	if(SoundType==STATICSOUND)
		Sound.AddStaticVolume(Index,lAdd);

	else if(SoundType==STREAMSOUND)
		Sound.AddStreamVolume(Index,lAdd);
	
	}
void SubVolume(LONG lAdd){


	if(SoundType==STATICSOUND)
		Sound.SubStaticVolume(Index,lAdd);

	else if(SoundType==STREAMSOUND)
		Sound.SubStreamVolume(Index,lAdd);

}

void SetPan(LONG lPan ){

	if(SoundType==STATICSOUND)
		Sound.SetStaticPan( Index,lPan );


	}
void MoveRightPan(LONG lAdd ){

	if(SoundType==STATICSOUND)
		Sound.AddStaticPan( Index,lAdd );

	}
void MoveLeftPan(LONG lSub ){

	if(SoundType==STATICSOUND)
		Sound.SubStaticPan( Index,lSub );
}


void SetFreq(DWORD dwFreq ){
	
	if(SoundType==STATICSOUND)
		Sound.SetStaticFreq(Index,dwFreq);
	
	}
void AddFreq(DWORD dwAdd ){


	if(SoundType==STATICSOUND)
		Sound.AddStaticFreq(Index,dwAdd);


}

void SubFreq(DWORD dwSub ){

	if(SoundType==STATICSOUND)
		Sound.SubStaticFreq(Index,dwSub);
}


protected:

	void Init(){
		Sound.InitDSound(hWnd);
		Sound.Set_dwNumStatics(staticCount);
		Sound.Set_dwNumStreams(streamCount);
		Initted=TRUE;

		}




protected:
	static ZLSOUND Sound;
	static DWORD staticCount;
	static DWORD streamCount;
	static BOOL Initted;
	static HWND hWnd;
	DWORD Index;
	DWORD SoundType;
	DWORD SoundState;

};
